#include "forms.h"
#include "confirm.h"
#include "FvwmCDE.h"
#include "interaction.h"
#include "minimized.h"
#include "interface.h"
#include "defs.h"
#include "sundry.h"
#include "panel.h"
#include <unistd.h>

/* pixmaps to use */
#include "icons/little_pixmap.xpm"
#include "icons/upside_down_pixmap.xpm"

/* some global variables */
int FvwmCDE_desktop = 1;	/* 1,2,3,4 */

/* take care of panel interaction */
void
check_panels (FD_panel * slideout, FL_OBJECT * obj)
{
  int i;

  for (i = 0; i < MAX_ENTRIES; i++)
    {
      if ((strlen (slideout->button_action[i]) > 0) &&
	  ((obj == slideout->button_label[i]) ||
	   (obj == slideout->button_pixmap[i])))
	{
	  fl_deactivate_object (obj);
	  fl_set_object_color (slideout->button_label[i], CUSTOM_COLOR2,
			       CUSTOM_COLOR2);
	  XFlush (disp);
	  SendInfoCheck (FvwmPipe, slideout->button_action[i], 0);
	  sleep (1);
	  fl_set_object_color (slideout->button_label[i], CUSTOM_COLOR1,
			       CUSTOM_COLOR1);
	  fl_activate_object (obj);
	  XFlush (disp);

	  /* the panels are supposed to disappear (I didn't know this) */
	  /* thanks to Guido Notari <guido.notari@jrc.it> for this and */
	  /* other useful hints.. */
	  fl_hide_form (slideout->panel);

	  /* and.. gotta change the button back */
	  /* reverse the little pointy pixmap */
	  if (slideout == Panel[0])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[0]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[0],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[0], 0);
	    }

	  if (slideout == Panel[1])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[1]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[1],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[1], 0);
	    }

	  if (slideout == Panel[2])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[2]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[2],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[2], 0);
	    }

	  if (slideout == Panel[3])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[3]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[3],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[3], 0);
	    }

	  if (slideout == Panel[4])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[4]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[4],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[4], 0);
	    }

	  if (slideout == Panel[5])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[5]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[5],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[5], 0);
	    }

	  if (slideout == Panel[6])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[6]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[6],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[6], 0);
	    }

	  if (slideout == Panel[7])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[7]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[7],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[7], 0);
	    }

	  if (slideout == Panel[8])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[8]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[8],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[8], 0);
	    }

	  if (slideout == Panel[9])
	    {
	      fl_free_pixmapbutton_pixmap (fd_FvwmCDE->panelbutton[9]);
	      fl_set_pixmapbutton_data (fd_FvwmCDE->panelbutton[9],
					little_pixmap_xpm);
	      fl_set_button (fd_FvwmCDE->panelbutton[9], 0);
	    }

	  XFlush (disp);
	}
    }
  return;
}

/* take care of interaction with the main panel */
void
check_buttons (FD_FvwmCDE * cde_panel, FL_OBJECT * obj)
{
  int screen, xofs, yofs;

  /* set sizing and location */
  /* needed so that the panels don't "creep" across the screen */
  screen = DefaultScreen (disp);
  xofs = (DisplayWidth (disp, screen) - fd_FvwmCDE->FvwmCDE->w) / 2;
  yofs = DisplayHeight (disp, screen) - fd_FvwmCDE->FvwmCDE->h;

  if (obj == cde_panel->panelbutton[0])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[0]->panel, xofs + 30, (yofs - 21) -
				Panel[0]->panel->h, Panel[0]->panel->w,
				Panel[0]->panel->h);
	  fl_show_form (Panel[0]->panel, FL_PLACE_GEOMETRY,
			FL_TRANSIENT, Panel[0]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[0]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[1])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[1]->panel, xofs + 86, (yofs - 21) -
				Panel[1]->panel->h, Panel[1]->panel->w,
				Panel[1]->panel->h);
	  fl_show_form (Panel[1]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[1]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[1]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[2])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[2]->panel, xofs + 142, (yofs - 21) -
				Panel[2]->panel->h, Panel[2]->panel->w,
				Panel[2]->panel->h);
	  fl_show_form (Panel[2]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[2]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[2]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[3])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[3]->panel, xofs + 198, (yofs - 21) -
				Panel[3]->panel->h, Panel[3]->panel->w,
				Panel[3]->panel->h);
	  fl_show_form (Panel[3]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[3]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[3]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[4])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[4]->panel, xofs + 254, (yofs - 21) -
				Panel[4]->panel->h, Panel[4]->panel->w,
				Panel[4]->panel->h);
	  fl_show_form (Panel[4]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[4]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[4]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[5])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[5]->panel, xofs + 660, (yofs - 21) -
				Panel[5]->panel->h,
				Panel[5]->panel->w,
				Panel[5]->panel->h);
	  fl_show_form (Panel[5]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[5]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[5]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[6])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[6]->panel, xofs + 716, (yofs - 21) -
				Panel[6]->panel->h,
				Panel[6]->panel->w,
				Panel[6]->panel->h);
	  fl_show_form (Panel[6]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[6]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[6]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[7])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[7]->panel, xofs + 772, (yofs - 21) -
				Panel[7]->panel->h, Panel[7]->panel->w,
				Panel[7]->panel->h);
	  fl_show_form (Panel[7]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[7]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[7]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[8])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[8]->panel, xofs + 828, (yofs - 21) -
				Panel[8]->panel->h, Panel[8]->panel->w,
				Panel[8]->panel->h);
	  fl_show_form (Panel[8]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[8]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[8]->panel);
	}
    }

  if (obj == cde_panel->panelbutton[9])
    {
      if (fl_get_button (obj))
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, upside_down_pixmap_xpm);
	  fl_set_form_geometry (Panel[9]->panel, xofs + 884, (yofs - 21) -
				Panel[9]->panel->h, Panel[9]->panel->w,
				Panel[9]->panel->h);
	  fl_show_form (Panel[9]->panel, FL_PLACE_GEOMETRY, FL_TRANSIENT,
			Panel[9]->label);
	}
      else
	{
	  fl_free_pixmapbutton_pixmap (obj);
	  fl_set_pixmapbutton_data (obj, little_pixmap_xpm);
	  fl_hide_form (Panel[9]->panel);
	}
    }

  if (obj == cde_panel->lock_button)
    SendInfoCheck (FvwmPipe, CmdList[LOCK], 0);

  if (obj == cde_panel->exit_button)
    {
      fl_deactivate_form (fd_FvwmCDE->FvwmCDE);
      fl_show_form (fd_confirm->confirm,
		    FL_PLACE_CENTER, FL_TRANSIENT, "Confirm");
      disable_all = 1;
    }

  /* the change-desktop commands */
  /* we have to "change the wallpaper" if necessary, too */
  if (obj == cde_panel->one_button && FvwmCDE_desktop != 1)
    {
      fl_deactivate_form (fd_FvwmCDE->FvwmCDE);
      SendInfoCheck (FvwmPipe, "Desk 0 0", 0);
      if (strlen (dt1back) > 0)
	system (dt1back);
      fl_activate_form (fd_FvwmCDE->FvwmCDE);
      FvwmCDE_desktop = 1;
    }

  if (obj == cde_panel->two_button && FvwmCDE_desktop != 2)
    {
      fl_deactivate_form (fd_FvwmCDE->FvwmCDE);
      SendInfoCheck (FvwmPipe, "Desk 0 1", 0);
      if (strlen (dt2back) > 0)
	system (dt2back);
      fl_activate_form (fd_FvwmCDE->FvwmCDE);
      FvwmCDE_desktop = 2;
    }

  if (obj == cde_panel->three_button && FvwmCDE_desktop != 3)
    {
      fl_deactivate_form (fd_FvwmCDE->FvwmCDE);
      SendInfoCheck (FvwmPipe, "Desk 0 2", 0);
      if (strlen (dt3back) > 0)
	system (dt3back);
      fl_activate_form (fd_FvwmCDE->FvwmCDE);
      FvwmCDE_desktop = 3;
    }

  if (obj == cde_panel->four_button && FvwmCDE_desktop != 4)
    {
      fl_deactivate_form (fd_FvwmCDE->FvwmCDE);
      SendInfoCheck (FvwmPipe, "Desk 0 3", 0);
      if (strlen (dt4back) > 0)
	system (dt4back);
      fl_activate_form (fd_FvwmCDE->FvwmCDE);
      FvwmCDE_desktop = 4;
    }

  /* the big guys */
  if (obj == cde_panel->button0)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (cde_panel->clock_pixmap, CUSTOM_COLOR2,
			   CUSTOM_COLOR2);
      update_calendar ();
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[0], 0);
      sleep (1);
      fl_set_object_color (cde_panel->clock_pixmap, CUSTOM_COLOR1,
			   CUSTOM_COLOR1);
      update_calendar ();
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button1)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (cde_panel->cal_pixmap, CUSTOM_COLOR2,
			   CUSTOM_COLOR2);
      force_calendar ();
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[1], 0);
      sleep (1);
      fl_set_object_color (cde_panel->cal_pixmap, CUSTOM_COLOR1,
			   CUSTOM_COLOR1);
      force_calendar ();
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button2)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[2], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button3)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[3], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button4)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[4], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button5)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[5], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button6)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[6], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button7)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[7], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button8)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[8], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->button9)
    {
      fl_deactivate_object (obj);
      fl_set_object_color (obj, CUSTOM_COLOR2, CUSTOM_COLOR2);
      XFlush (disp);
      SendInfoCheck (FvwmPipe, CmdList[9], 0);
      sleep (1);
      fl_set_object_color (obj, CUSTOM_COLOR1, CUSTOM_COLOR1);
      XFlush (disp);
      fl_activate_object (obj);
    }

  if (obj == cde_panel->window_ops_button)
    SendInfoCheck (FvwmPipe, CmdList[10], 0);

  if (obj == cde_panel->minimize_button)
    {
      fl_hide_form (fd_FvwmCDE->FvwmCDE);
      switch (FvwmCDE_desktop)
	{
	case 1:
	  fl_set_object_label (fd_FvwmCDE_minimized->label, "One");
	  break;
	case 2:
	  fl_set_object_label (fd_FvwmCDE_minimized->label, "Two");
	  break;
	case 3:
	  fl_set_object_label (fd_FvwmCDE_minimized->label, "Three");
	  break;
	case 4:
	  fl_set_object_label (fd_FvwmCDE_minimized->label, "Four");
	  break;
	default:
	  break;
	}
      fl_show_form (fd_FvwmCDE_minimized->FvwmCDE_minimized,
		    FL_PLACE_GEOMETRY, FL_TRANSIENT, "FvwmCDE");
    }

  return;
}
