#include <stdio.h>
#include <signal.h>
#include <fcntl.h>
#include <string.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>
#include "interface.h"
#include "defs.h"

int FvwmPipe[2];

/* when Fvwm gets it.. */
void
DeadPipe (int signal)
{
  exit (0);
}

/* SendInfo wrapper for the blinky light */
void
SendInfoCheck (int *fd, char *message, unsigned long window)
{
  /* increment the countdown timer by 1500 jiffies (15 seconds) */
  if (!strncasecmp (message, "Exec", 4))
    ledCounter += 1500;

  SendInfo (fd, message, window);
}

/* when a window gets mapped, decrease the ledCounter */
void
window_name (unsigned long *body)
{
  ledCounter -= 1500;;
  if (ledCounter < 0)
    ledCounter = 0;
}

/* adapted from process_message in FvwmDebug.c */
void
process_message (unsigned long type, unsigned long *body)
{
  switch (type)
    {
    case M_ADD_WINDOW:
    case M_CONFIGURE_WINDOW:
    case M_DESTROY_WINDOW:
    case M_FOCUS_CHANGE:
    case M_NEW_PAGE:
    case M_NEW_DESK:
    case M_RAISE_WINDOW:
    case M_LOWER_WINDOW:
    case M_ICONIFY:
    case M_MAP:
    case M_ICON_LOCATION:
    case M_DEICONIFY:
      break;
    case M_WINDOW_NAME:
      window_name (body);
      break;
    case M_ICON_NAME:
    case M_RES_CLASS:
    case M_RES_NAME:
    case M_END_WINDOWLIST:
    case M_DEFAULTICON:
    case M_ICON_FILE:
    default:
      break;
    }
}
