#ifndef FD_panel_h_
#define FD_panel_h_

#include "defs.h"

/* entries per panel: this is as large as a 1024x768 screen allows */
#define MAX_ENTRIES  12

typedef struct
  {
    FL_FORM *panel;
    void *vdata;
    long ldata;
    FL_OBJECT *panelbox;
    FL_OBJECT *button_pixmap[MAX_ENTRIES];
    FL_OBJECT *button_label[MAX_ENTRIES];
    char button_action[MAX_ENTRIES][CMDLEN];
    char label[_POSIX_PATH_MAX];
  }
FD_panel;

extern FD_panel *create_form_panel (int);
extern void add_to_panel (FD_panel *, char *);
extern void trim_panel (FD_panel *);

/* global variables */
extern FD_panel *Panel[10];

#endif
